import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.Serializable;


public class Facture implements Serializable{

	private static final long serialVersionUID = 1L;
	double v, montantfact;
	String destinataire; // Est utile tout de meme pour la gestion faite cot serveur

	public Facture(double v, String destinataire){
		this.v=v;
		this.montantfact=v*1.5;
		this.destinataire=destinataire;
	}
	public String toString(){
		return "Facture pour "+ destinataire +" pour quantite " + v + " Montant TTC=" + montantfact;
	}
	// Pas la peine de serialiser le destinataire car le client  qui on envoie la facture
	// sait pertinemment quel est son nom!
	private void writeObject(ObjectOutputStream os) throws IOException {
		os.writeDouble(v);
		os.writeDouble(montantfact);

	}
	private void readObject(ObjectInputStream os) throws IOException {
		v=os.readDouble();
		montantfact=os.readDouble();
	}

}
