import java.rmi.RemoteException;
import java.rmi.server.UnicastRemoteObject;


public class ServiceImpl extends UnicastRemoteObject implements Service{

	
	int val=1;
	public ServiceImpl() throws RemoteException {
		super();
	}
	
	@Override
	public int getVal() throws RemoteException {
		return val;
	}
	
	@Override
	public  synchronized int  setVal(int v, Facturation cname) throws RemoteException {
		// la mthode est synchronized car interdit que plusieurs clients modifient val en meme temps
		val=val*v;
		try {
			Thread.sleep(500);
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
		Facture f=new Facture(v,cname.getName());// getName invoque via le reseau... peut etre penalisant ! On aimerait utiliser  la place un smartproxy
		cname.facturer(f); // le champ destinataire ne sera pas srialis (voir classe Facture et ses mthodes de de/serialisation) car cname est le bon client: pas la peine de lui redire quel est son nom !
		System.out.println("Nouvelle " + f);
		return val;
	}
}
